<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2024 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2024-09-30
 */
define('IN_DOUCO', true);

$_CUR = 'sn';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 载入并实例化类库
require (ROOT_PATH . 'include/sn.class.php');
$dou_sn = new Sn();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 防伪码列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['sn']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['sn_add'],
            'href' => 'sn.php?rec=add' 
    ));
  
    // 启用的列
    $column = $dou_sn->column();
 
    // 列表头部
    $head_lang = $dou->get_row('sn', $column['char'], "id = '1'");
    if (!$head_lang) {
        $query = $dou->query("INSERT INTO " . $dou->table('sn') . " (id, column_a, column_b, column_c, column_d, column_e, column_f, column_g, column_h, column_i)" . " VALUES ('1', '批次','序列号（不可重复）','产品名称','价格','型号','颜色','产地','生产日期','销售区域')");
        $dou->dou_header('sn.php');
    }
    
    // 生成筛选条件
    $key = array();
    foreach ($column['array'] as $value) {
        $v['value'] = $value;
        $v['name'] = $head_lang[$value] ? $head_lang[$value] : $column['caps'][$value];
        $v['cur'] = ($value == $_REQUEST['key']) ? true : false;
        $key[] = $v;
    }
 
    // where
    $where = " WHERE id != '1'";
    
    // 筛选关键词
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    if ($keyword)
        $where .= " AND $_REQUEST[key] LIKE '%$keyword%'";
    
    // 把第一个AND替换成WHERE
    $_SESSION['where'] = $where;
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('sn') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, 'sn.php', $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $sn_list[] = array (
                "id" => $row['id'],
                "list" => $dou->get_row('sn', $column['char'], "id = '$row[id]'"),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 判断是否安装会员导出功能
    if (file_exists(ROOT_PATH . ADMIN_PATH . '/include/phpexcel/excel.class.php'))
        $smarty->assign('excel', true);
    
    // 赋值给模板
    $smarty->assign('key', $key);
    $smarty->assign('keyword', $keyword);
    $smarty->assign('head_caps', $column['caps']);
    $smarty->assign('head_lang', $head_lang);
    $smarty->assign('sn_list', $sn_list);
    $smarty->assign('column_data', $column['data']);
    
    $smarty->display('sn.htm');
} 

/**
 * +----------------------------------------------------------
 * 防伪码添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $id = $dou->auto_id('sn');
    
    $smarty->assign('ur_here', $id == 1 ? $_LANG['sn_add_head'] : $_LANG['sn_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['sn'],
            'href' => 'sn.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 获取要显示的列
    $item = $dou_sn->item($id);
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('item', $item);
    $smarty->assign('sn', $sn);
    $smarty->assign('id', $id);
    
    $smarty->display('sn.htm');
} 

elseif ($rec == 'insert') {
    // 验证并获取合法的ID
    $number = $check->is_number($_REQUEST['number']) ? $_REQUEST['number'] : 1;
    $type = $check->is_letter($_REQUEST['type']) ? $_REQUEST['type'] : 'batch';
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    // 格式化数据
    $add_time = time();
 
    if ($type == 'batch') { // 批量生成
        for($i = 1; $i <= $number; $i++) {
            $column_b = $dou_sn->rand_column_b(); // 随机序列号
            $sql = "INSERT INTO " . $dou->table('sn') . " (id, column_a, column_b, column_c, column_d, column_e, column_f, column_g, column_h, column_i, column_j, column_k, column_l, column_m, column_n, column_o, column_p, column_q, column_r, column_s, column_t, column_u, column_v, column_w, column_x, column_y, column_z, add_time)" . " VALUES (NULL, '$_POST[column_a]', '$column_b', '$_POST[column_c]', '$_POST[column_d]', '$_POST[column_e]', '$_POST[column_f]', '$_POST[column_g]', '$_POST[column_h]', '$_POST[column_i]', '$_POST[column_j]', '$_POST[column_k]', '$_POST[column_l]', '$_POST[column_m]', '$_POST[column_n]', '$_POST[column_o]', '$_POST[column_p]', '$_POST[column_q]', '$_POST[column_r]', '$_POST[column_s]', '$_POST[column_t]', '$_POST[column_u]', '$_POST[column_v]', '$_POST[column_w]', '$_POST[column_x]', '$_POST[column_y]', '$_POST[column_z]', '$add_time')";
             $dou->query($sql);
        }
    } else { // 单个生成
        $sql = "INSERT INTO " . $dou->table('sn') . " (id, column_a, column_b, column_c, column_d, column_e, column_f, column_g, column_h, column_i, column_j, column_k, column_l, column_m, column_n, column_o, column_p, column_q, column_r, column_s, column_t, column_u, column_v, column_w, column_x, column_y, column_z, add_time)" . " VALUES (NULL, '$_POST[column_a]', '$_POST[column_b]', '$_POST[column_c]', '$_POST[column_d]', '$_POST[column_e]', '$_POST[column_f]', '$_POST[column_g]', '$_POST[column_h]', '$_POST[column_i]', '$_POST[column_j]', '$_POST[column_k]', '$_POST[column_l]', '$_POST[column_m]', '$_POST[column_n]', '$_POST[column_o]', '$_POST[column_p]', '$_POST[column_q]', '$_POST[column_r]', '$_POST[column_s]', '$_POST[column_t]', '$_POST[column_u]', '$_POST[column_v]', '$_POST[column_w]', '$_POST[column_x]', '$_POST[column_y]', '$_POST[column_z]', '$add_time')";
         $dou->query($sql);
    }
    
    $dou->create_admin_log($_LANG['sn_add'] . ': ' . $_POST['column_b'] . 'x' . $number);
    $dou->dou_msg($_LANG['sn_add_succes'], 'sn.php');
} 

/**
 * +----------------------------------------------------------
 * 防伪码编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $smarty->assign('ur_here', $id == 1 ? $_LANG['sn_edit_head'] : $_LANG['sn_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['sn'],
            'href' => 'sn.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 其它字段
    $item = $dou_sn->item($id);
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('id', $id);
    $smarty->assign('item', $item);
    
    $smarty->display('sn.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('sn') . " SET column_a = '$_POST[column_a]', column_b = '$_POST[column_b]', column_c = '$_POST[column_c]', column_d = '$_POST[column_d]', column_e = '$_POST[column_e]', column_f = '$_POST[column_f]', column_g = '$_POST[column_g]', column_h = '$_POST[column_h]', column_i = '$_POST[column_i]', column_j = '$_POST[column_j]', column_k = '$_POST[column_k]', column_l = '$_POST[column_l]', column_m = '$_POST[column_m]', column_n = '$_POST[column_n]', column_o = '$_POST[column_o]', column_p = '$_POST[column_p]', column_q = '$_POST[column_q]', column_r = '$_POST[column_r]', column_s = '$_POST[column_s]', column_t = '$_POST[column_t]', column_u = '$_POST[column_u]', column_v = '$_POST[column_v]', column_w = '$_POST[column_w]', column_x = '$_POST[column_x]', column_y = '$_POST[column_y]', column_z = '$_POST[column_z]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['sn_edit'] . ': ' . $_POST['column_b']);
    $dou->dou_msg($_LANG['sn_edit_succes'], 'sn.php');
}

/**
 * +----------------------------------------------------------
 * 防伪码删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'sn.php');
    $column_b = $dou->get_one("SELECT column_b FROM " . $dou->table('sn') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['sn_del'] . ': ' . $column_b);
        $dou->delete('sn', "id = $id", 'sn.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $column_b, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'sn.php', '', '30', "sn.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    // 判断是否安装会员导出功能
    if (file_exists($excel_file = ROOT_PATH . ADMIN_PATH . '/include/phpexcel/excel.class.php')) {
        include_once($excel_file);
        $excel = new Excel();
    }
    
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') { // 批量删除会员
            $dou->del_all('sn', $_POST['checkbox'], 'id');
        } elseif ($_POST['action'] == 'excel') { // 导出所选会员
            $excel->export_excel('sn', excel_sn_list($_POST['checkbox']));
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        if ($_POST['action'] == 'excel_all') { // 导出所有
            $excel->export_excel('sn', excel_sn_list());
            exit;
        }
        
        $dou->dou_msg($_LANG['sn_select_empty']);
    }
}

/**
 * +----------------------------------------------------------
 * 参数设置
 * +----------------------------------------------------------
 */
elseif ($rec == 'set') {
    $set_list = array('sn_column', 'sn_length', 'sn_char');
    foreach ($set_list as $name) {
        if (!$dou->value_exist('parameter', 'name', $name)) {
            $dou->query("INSERT INTO " . $dou->table('parameter') . " (id, name, lang, value, cue, `group`)" . " VALUES (NULL, '$name', '" . $_LANG['sn_' . $name . '_lang'] . "', '" . $_LANG['sn_' . $name . '_value'] . "', '" . $_LANG['sn_' . $name . '_cue'] . "', 'sn')");
        }
    }
    $dou->dou_header('parameter.php?rec=set&group=sn');
}

// 导入防伪码
elseif ($rec == 'import_execl') {
    include_once(ROOT_PATH . ADMIN_PATH . '/include/phpexcel/excel.class.php');
    $excel = new Excel();

    // 启用的列
    $column = $dou_sn->column();
    
    // 需要插入数据的字段
    $field_name_list = $column['char'];
    
    // 需要补充插入的数据
    $add_time = time();
    $data = array (
            "field_name_list" => ', add_time',
            "field_value_list" => ", '$add_time'"
    );

    if ($excel->import_execl('file', 'sn', $field_name_list, $data) == 'success') {
        $dou->dou_header('sn.php');
    }
}

/**
 * +----------------------------------------------------------
 * 导出的会员数据
 * +----------------------------------------------------------
 * $checkbox 所选的会员条目
 * +----------------------------------------------------------
 */
function excel_sn_list($checkbox = '') {
    // 启用的列
    $column = $GLOBALS['dou_sn']->column();
    
    // 导出的字段名称
    $head = $GLOBALS['dou']->get_row('sn', '*', "id = '1'");
    foreach ((array) $column['array'] as $value) {
        $excel_list['head'][] = $head[$value];
    }
    
    // 导出列表
    if ($checkbox) {
        $where = " WHERE id != '1' AND id IN (" . implode(',', $checkbox) . ")";
    } elseif($_SESSION['where']) {
        $where = $_SESSION['where'];
    } else {
        $where = " WHERE id != '1'";
    }
    
    $query = $GLOBALS['dou']->query("SELECT * FROM " . $GLOBALS['dou']->table('sn') . $where . " ORDER BY id DESC");
    while ($row = $GLOBALS['dou']->fetch_array($query)) {
        unset($list);
        foreach ((array) $column['array'] as $value) {
            $list[] = $row[$value];
        }
        $excel_list['list'][] = $list;
    }
    
    return $excel_list;
}

?>