<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2024 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2024-09-30
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Sn {
    var $end_letter;
    
    /**
     * +----------------------------------------------------------
     * 构造函数
     * +----------------------------------------------------------
     */
    function __construct($end_letter = 'i') {
        $this->end_letter = $GLOBALS['_PARAM']['sn_end_letter'] ? $GLOBALS['_PARAM']['sn_end_letter'] : $end_letter;
    }
 
    // 构造函数.兼容PHP4
    function Sn($end_letter = '') {
        $this->__construct($end_letter);
    }
    
    /**
     * +----------------------------------------------------------
     * 开启的列
     * +----------------------------------------------------------
     */
    function column() {
        $letter_list = $this->letter_list();
        foreach ($letter_list as $letter) {
            $column['array'][] = 'column_' . $letter;
            $column['caps'][] = strtoupper($letter);
            
            if ($letter == $this->end_letter)
                break; // 当为最后一个限定值时终止循环
        }
        
        $column['char'] = implode(', ', $column['array']);
        
        return $column;
    }
 
    /**
     * +----------------------------------------------------------
     * 添加或编辑序列号
     * +----------------------------------------------------------
     */
    function item($id = '') {
        $letter_list = $this->letter_list();
        if ($id != '1')
            $head = $GLOBALS['dou']->get_row('sn', '*', "id = '1'");
        $sn = $GLOBALS['dou']->get_row('sn', '*', "id = '$id'");
        
        // 初始化
        if (!$sn) {
            $sn['column_a'] = $this->rand_column_a();// 随机批次
            $sn['column_b'] = $this->rand_column_b();// 随机序列号
        }
        
        foreach ($letter_list as $letter) {
            $item[] = array (
                    "field" => 'column_' . $letter,
                    "caps" => strtoupper($letter),
                    "name" => $head['column_' . $letter] ? $head['column_' . $letter] : strtoupper($letter),
                    "value" => $sn['column_' . $letter]
            );
            
            if ($letter == $this->end_letter)
                break; // 当为最后一个限定值时终止循环
        }
        
        return $item;
    }
    
    /**
     * +----------------------------------------------------------
     * 字母表
     * +----------------------------------------------------------
     */
    function letter_list() {
        $letter_list = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z');
        
        return $letter_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 随机序列号，不能判断重复，因为并发高时判断会失效，所以处理方法是，序列号字段设置为唯一，如果重复，则生成不成功
     * +----------------------------------------------------------
     */
    function rand_column_b() {
        $char = $GLOBALS['_PARAM']['sn_char'] ? $GLOBALS['_PARAM']['sn_char'] : 'number';
        $length = $GLOBALS['_PARAM']['sn_length'] ? $GLOBALS['_PARAM']['sn_length'] : 16;
        $column_b = $GLOBALS['dou']->create_rand_string($char, $length);
        
        return $column_b;
    }
 
    /**
     * +----------------------------------------------------------
     * 随机分组编号
     * +----------------------------------------------------------
     */
    function rand_column_a() {
        $column_a = $GLOBALS['dou']->create_rand_string('number', 4);
        if ($GLOBALS['dou']->value_exist('sn', 'column_a', $column_a)) {
            $this->rand_column_a();
        } else {
            return $column_a;
        }
    }
    
}

?>