// pages/sn/sn.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  onLoad: function(options) {
    var that = this
        
    wx.setNavigationBarTitle({
      title: app.title.sn
    })
   
    // 设置转发标题缓存
    wx.setStorageSync('shareTitle', app.title.sn)

    // 显示转发按钮
    dou.showShareMenu()
        
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
  },

  // 获取数据
  douSearch: function(e) {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'sn.php?rec=search',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        code: e.detail.value.code
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        console.log(res.data)
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong)
        }
        
        that.setData({
          result: res.data.result,
          code: res.data.code
        })
      }
    })
  },

  // 清楚搜索
  douClear: function(e) {
    var that = this;
    
    that.setData({
      result: [],
      code: ''
    })
  },

})