<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2024 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2024-09-30
 */
define('IN_DOUCO', true);

$sub = 'search|result';
$subbox = array(
        "module" => 'sn',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'sn';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// 开启SESSION
session_start();

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'sn', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 防伪码列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->set_token('sn'));
 
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('sn'));
    $smarty->assign('ur_here', $dou->ur_here('sn'));
    $smarty->assign('head', $_LANG['sn']);

    $smarty->display('sn.dwt');
}

/**
 * +----------------------------------------------------------
 * 搜索
 * +----------------------------------------------------------
 */
elseif ($rec == 'search') {
    if (!$_POST['code']) {
        $wrong['code'] = $_LANG['sn_code'] . $_LANG['is_empty'];
    } elseif (!$check->is_basic_string($_POST['code'])) {
        $wrong['code'] = $_LANG['sn_code'] . $_LANG['illegal_char'];
    }
    
    // 判断验证码
    $captcha = $check->is_captcha(trim($_POST['captcha'])) ? strtoupper(trim($_POST['captcha'])) : '';
    if ($_CFG['captcha'] && md5($captcha . DOU_SHELL) != $_SESSION['captcha'])
        $wrong['captcha'] = $_LANG['captcha_wrong'];
    
    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }
    
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_URL['sn']);
    }
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token'], 'sn');

    $dou->dou_header($dou->param($_URL['result'] . '&code=' . $_POST['code']));
}

/**
 * +----------------------------------------------------------
 * 搜索结果
 * +----------------------------------------------------------
 */
elseif ($rec == 'result') {
    // 载入并实例化类库
    require (ROOT_PATH . 'include/sn.class.php');
    $dou_sn = new Sn();

    // 序列号
    $code = $check->is_basic_string($_GET['code']) ? $_GET['code'] : '';
    
    // 获取查询内容
    $id = $dou->get_one("SELECT id FROM " . $dou->table('sn') . " WHERE column_b = '$code'");
    if (!$id)
        $dou->dou_msg($_LANG['sn_wrong'], $dou->param($_URL['sn']));
    
    $item = $dou_sn->item($id);
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('sn'));
    $smarty->assign('ur_here', $dou->ur_here('sn'));
    $smarty->assign('head', $_LANG['sn']);
    $smarty->assign('code', $code);
    $smarty->assign('item', $item);

    $smarty->display('sn.dwt');
}

?>